import sys

from twisted.internet import reactor
from twisted.internet.protocol import Factory
from twisted.internet.protocol import Protocol
from twisted.internet.serialport import SerialPort
from twisted.python import log

log.startLogging(sys.stdout)
client_list = []#TCP clients connecting to me
usb_list = []

class USBClient(Protocol):

    def __init__(self, network):
        self.network = network
        self.usb_list = []

    def connectionFailed(self):
        print "Connection Failed:", self
        reactor.stop()

    def connectionMade(self):
        usb_list.append(self)
        print 'Connected to USB modem'
        USBClient.sendLine(self, 'AT\r\n')

    def dataReceived(self, data):
        print "Data received", repr(data)
        print "Data received! with %d bytes!" % len(data)

        for cli in client_list:
            cli.transport.write(data)
        #self.network.notifyAll(data)# !!AArgh..!Could not get this to work
        pass

    def lineReceived(self, line):
        print "Line received", repr(line)

    def sendLine(self, cmd):
        print cmd
        self.transport.write(cmd + "\r\n")

    def outReceived(self, data):
        print "outReceived! with %d bytes!" % len(data)
        self.data = self.data + data

class CommandRx(Protocol):


    def connectionMade(self):
        print 'Connection received from tcp..'
        client_list.append(self)

    def dataReceived(self, data):
        print 'Command receive', repr(data)
        for usb in usb_list:
            usb.transport.write(data)

    def connectionLost(self, reason):
        print 'Connection lost', reason
        if self in client_list:
            print "Removing " + str(self)
            client_list.remove(self)

class CommandRxFactory(Factory):
    protocol = CommandRx
    def __init__(self):
        self.client_list = []

    def notifyAll(self, data):
        for cli in self.client_list:
            cli.transport.write('yipee')

if __name__ == '__main__':

    tcpfactory = CommandRxFactory()
    reactor.listenTCP(9100, tcpfactory)
    SerialPort(USBClient(tcpfactory), '/dev/ttyUSB0', reactor, baudrate='115200')
    reactor.run()
